function dft_demo_CRC

% Demonstrating properties of DFT
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)

m0=1;
while m0==1,
m1=menu('Select','Symmetry properties','Signal spectra','Shift theorem','Convolution theorem','Lowpass filtering');
switch m1
   case 1,
      load axes32;
      sp=fft2(axes32);
      fig_n(6);
      figure(1);
      display_1(axes32);%colormap(jet);
      title('Initial image','FontWeight','Bold');
      figure(2);
      display_1(abs(fftshift(sp)).^0.3);colormap(jet)
      title('Abs(Image spectrum).\^0.3','FontWeight','Bold');
      figure(3)
      display_1(real(ifft2(sp)));%colormap(jet);
      title('IDFTof image spectrum','FontWeight','Bold');
      uicontrol(gcf,'Style',...
   	'text','Position',[1 1 150 25],...
   	'String','Press any button when ready');
      drawnow
      figure(4);
      display_1(real(fft2(sp)));%colormap(jet)
      title('DFT of image spectrum','FontWeight','Bold');
      figure(5);
      display_1(real(fft2(real(sp))));%colormap(jet)
      title('IDFT of real(Image spectrum))','FontWeight','Bold');
      figure(6);
      display_1(real(ifft2(i*imag(sp))));%colormap(jet)
      title('IDFT of imag(Image spectrum)','FontWeight','Bold');
case 2,
   m2=menu('Select','Sinusoidal signal','Image','Image fragments');
   switch m2,
   case 1,
      s=1;
      while s==1,
%       Fr=input('Frequency/MaxFrequency=');
      Fr=inputdlg('Enter Frequency/MaxFrequency');
      Fr=str2double(Fr);
      fig_n(3);
      k=0:127;
      figure(1);
      a1=sin(2*pi*k*Fr/2);
      stem(k,a1,'.','LineWidth',2); axis([0 127 -1 1]);
      grid on;title('Signal, Fr=5/128','FontWeight','Bold');
      set(gca,'FontWeight','Bold')
      sp1=abs(fft(a1));
      sp1=sp1/max(sp1);
      figure(2);stem(k,sp1,'.','LineWidth',2);
      title('DFT spectrum','FontWeight','Bold');
      axis([0 127 0 1]);grid on;
      xlabel('Frequency index','FontWeight','Bold')
      set(gca,'FontWeight','Bold')
      
      figure(3);stem((k-64)/128,fftshift(sp1),'.','LineWidth',2);
      title('Centered DFT spectrum','FontWeight','Bold');
      axis tight;grid on;
      xlabel('Normalized frequency','FontWeight','Bold')
      set(gca,'FontWeight','Bold');
      s=menu('Another frequency?','Yes','No');
      end
   case 2,
      m3=menu('Select image','Ango','MRI-brain','Barbara','Text');
      switch m3
      case 1, load ango;INPIMG=ango-mean(ango(:));
      case 2, load brain;INPIMG=brain-mean(brain(:));
      case 3, load barbara;INPIMG=barbara-mean(barbara(:));
      case 4, load text256; INPIMG=text256-mean(text256(:));
      end
      sp=abs(fft2(INPIMG));
      fig_n(4);
      figure(1);
      display_1(INPIMG);
      title('Input image','FontWeight','Bold');
      figure(2);
      display_1(sp);colormap(jet)
      title('Abs(Spectrum)','FontWeight','Bold');
      figure(3);
      display_1(fftshift(sp));colormap(jet)
      title('fftshift(Abs(Spectrum))','FontWeight','Bold');
      figure(4);
      display_1(fftshift(sp.^0.3));colormap(jet)
      title('fftshift(Abs(Spectrum).\^0.3)','FontWeight','Bold');
   case 3,
      m3=menu('Select','Ango','MRI-brain','Barbara','Text');
      switch m3
      case 1, load ango;INPIMG=ango;
      case 2, load brain;INPIMG=brain;
      case 3, load barbara;INPIMG=barbara;
      case 4, load text256; INPIMG=text256;
      end
      s=1;
      while s==1,
         frgm=frag_ment(INPIMG,32,32);
         frgm=frgm-mean(frgm(:));
         sp=abs(fft2(frgm));
      	 fig_n(4);
      	 figure(1);display_1(frgm);
         title('Input image','FontWeight','Bold');drawnow
      	 figure(2);display_1(sp);
         title('Abs(Spectrum)','FontWeight','Bold');drawnow
      	 figure(3);display_1(fftshift(sp));
         title('fftshift(Abs(Spectrum))','FontWeight','Bold');drawnow
         figure(4);display_1(fftshift(sp.^0.3));
         title('fftshift(Abs(Spectrum).\^0.3)','FontWeight','Bold');drawnow
         s=menu('Another fragment?','Yes','No');
      end
   end
case 3,
    load eye32;
    fig_n(6);
    figure(1);
    INPIMG1=kron([0 0 0;0 1 0;0 0 0],eye32);
    display_1(INPIMG1); 
    title('Input image','FontWeight','Bold');
    sp1=abs(fft2(INPIMG1));
    figure(4);
    display_1(fftshift(sp1));colormap(jet);
    title('Abs(Image Spectrum)','FontWeight','Bold');
    figure(2);
    INPIMG2=kron([1 0 0;0 0 0;0 0 0],eye32);
    display_1(INPIMG2); 
    title('Shifted input image','FontWeight','Bold');
    sp2=abs(fft2(INPIMG2));
    figure(5);
    display_1(fftshift(sp2));colormap(jet);
    title('Abs(Image Spectrum)','FontWeight','Bold');
    figure(3);
    INPIMG3=fftshift(kron([0 0 0;0 1 0;0 0 0],eye32));
    display_1(INPIMG3); 
    title('Cyclic shifted input image','FontWeight','Bold');
    sp3=abs(fft2(INPIMG3));
    figure(6);
    display_1(fftshift(sp3));colormap(jet);
    title('Abs(Image Spectrum)','FontWeight','Bold');
case 4,
    load eye32;
    load tau; tau=tau(2:33,2:33);
    tau=tau/max(tau(:));tau=tau-mean(tau(:));tau(17,17)=20; 
    eye32=eye32-mean(eye32(:));
    INPIMG1=kron([0 0 0;0 1 0;0 0 0],eye32);
    INPIMG1(17,17)=0000;INPIMG1(2,95)=1000;INPIMG1(95,2)=1000;INPIMG1(80,80)=0000;
    INPIMG2=kron([0 0 0;0 1 0;0 0 0],tau);
    sp1=fft2(INPIMG1);
    sp2=fft2(INPIMG2);
    OUT1=real(ifft2(sp1.*sp2));
    OUT2=conv2(INPIMG1,tau,'same');
    fig_n(4);
    figure(1);
    display_1((INPIMG1-min(INPIMG1(:))).^0.3);
    title('Input image 1','FontWeight','Bold');
    figure(2);
    display_1((INPIMG2-min(INPIMG2(:))).^0.3);
    title('Input image 2','FontWeight','Bold');
    figure(3);
    display_1(fftshift(OUT1));
    title('Convolution of images via DFT','FontWeight','Bold');
    figure(4);
    display_1(OUT2);
    title('Direct image convolution','FontWeight','Bold');
 case 5,
    load barbara;
    s=1;
    while s==1,
    BWXY=inputdlg({'Enter X-bandwidth (in fraction of baseband)','Enter Y-bandwidth (in fraction of baseband)'},........
        'Enter',1,{'0.1','0.5'});
    BWX=str2double(BWXY(1));
    BWY=str2double(BWXY(2));
    OUTIMG=low_pass(barbara,BWX,BWY);
    s=menu('Other bandwidth?','Yes','No');
    end
end
 m0=menu('Continue?','Yes','No');
end

%-----------------------------------------------------------------
function fig_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
   
%------------------------------------------------------
function display_1(INPIMG)
% Displays a 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display_1(INPIMG)

colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
%---------------------------------------------------------
function OUTIMG=frag_ment(INPIMG,LX,LY)

% Interactive selection of an image fragment of LXxLY pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Call OUTIMG=frag_ment(INPIMG,LX,LY);
clf
[SzX SzY]=size(INPIMG);
LxL=LX-fix((LX-1)/2)-1; LxR=LX-LxL;
LyL=LY-fix((LY-1)/2)-1; LyR=LY-LyL;

fig_n(1);
display_1(INPIMG);title(['Select center of the ',num2str(LX),'x',num2str(LY),' window'],'FontWeight','Bold') 
[Y X]=ginput(1);
Y=fix(Y);
X=fix(X);

Xu=X-LxL; if Xu<1,Xl=1;end
Xd=X+LxR-1; if Xd>SzX, Xd=SzX;end
Yl=Y-LyL; if Yl<1,Yl=1;end
Yr=Y+LyR-1;if Yr>SzY, Yr=SzY;end
OUTIMG=INPIMG(Xu:Xd,Yl:Yr);

%----------------------------------------------------------------
function OUTIMG=low_pass(INPIMG,BWX,BWY);

% Low pass filtering of an image
% BWX and BWY are fractions of bandwidth along X and Y to be left
% Processing is quantized if QuantlFlag==1
% Processing is displayed if DisplFlag==1
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il).  
% Call OUTIMG=low_pass(INPIMG,BWX,BWY);

fig_n(6);
figure(1);display_1(INPIMG);title('Input image','FontWeight','Bold');drawnow;
[SzX SzY]=size(INPIMG);
BX=round(SzX*(1-BWX)/2);
BY=round(SzX*(1-BWY)/2);
sp=fft2(INPIMG);
figure(2);
display_1(abs(sp).^0.3);colormap(jet);
title('abs(Image spectrum).\^0.3','FontWeight','Bold')
mask=ones(SzX, SzY);
mask(SzX/2+1-BX:SzX/2+1+BX,:)=zeros(2*BX+1,SzY);
mask(:,SzY/2+1-BY:SzY/2+1+BY)=zeros(SzX,2*BY+1);
figure(3);display_1(mask.*abs(sp).^0.3);colormap(jet)
title(['Lowpass filter mask, BWX=',num2str(BWX),'; BWY=',num2str(BWY)],'FontWeight','Bold');
drawnow;
OUTIMG=real(ifft2(sp.*mask));
figure(4);display_1(OUTIMG);
title(['Lowpass filtered image, BWX=',num2str(BWX),'; BWY=',num2str(BWY)],'FontWeight','Bold');
drawnow;
figure(5);display_1(fftshift((mask+0.75).*abs(sp).^0.3));colormap(jet)
title(['fftshift(Lowpass filter mask), BWX=',num2str(BWX),'; BWY=',num2str(BWY)],'FontWeight','Bold');
drawnow;
figure(6);display_1(INPIMG-OUTIMG);
title('Initial image - lowpass filtered image','FontWeight','Bold');
drawnow
%--------------------------------------------------------------------




