function corr_comparison_CRC;

% Comparison of Matched Filter (MF) and Optimal Adaptive (OAC) Correlators
% Target is to be selected manually from iINPIMG2
% 
% 
close all
load mishka_left; INPIMG1=mish_left;
load mishka_right; INPIMG2=mishka_right;
[SzX SzY]=size(INPIMG1);
display_1(INPIMG2);
title('Select a target','FontWeight','Bold'); 
coor=fix(ginput(1));Xt=round(coor(2))-1;Yt=round(coor(1))-1;

RR=[7 9 11 13 15 19 23 27 31 35 39];
r=menu('Select target size','15','19','23','27','31','39','47','57');
R=RR(r);
mask=rad_apodmask_CRC(R);
TARGIMG_zmn=INPIMG2;
TARGET=zeros(SzX,SzY);TARGET(fix(SzX/2)+1,fix(SzY/2)+1)=1;
Xu=Xt-R;if Xu<1, Xu=1;end
Xd=Xt+R;if Xt+R>SzX,Xd=SzX;end
Yl=Yt-R;if Yt-R<1,Yl=1;end
Yr=Yt+R;if Yr>SzY,Yr=SzY;end
mask=conv2(TARGET,mask,'same');
TARGET=(conv2(TARGET,TARGIMG_zmn(Xu:Xd,Yl:Yr),'same')).*mask;

if SzX<100,Xext=fix(SzX/2)-1; else Xext=50;end
if SzY<100,Yext=fix(SzY/2)-1; else Yext=50;end

figure_n(4);
INPIMG2=img_ext(INPIMG2,Xext,Yext);
INPIMG2(Xt:Xt+2*Xext,Yt:Yt+2*Yext)=INPIMG2(Xt:Xt+2*Xext,Yt:Yt+2*Yext)+1*TARGET(fix(SzX/2)-Xext:fix(SzX/2)+Xext,fix(SzY/2)-Yext:fix(SzY/2)+Yext);
INPIMG2=INPIMG2(Xext:SzX+Xext-1,Yext:SzY+Yext-1);
mx1=max(INPIMG1(:));
mx2=max(INPIMG2(:));
figure(1);
display_1([INPIMG1/max(INPIMG1(:)),INPIMG2/max(INPIMG2(:))]);
title('Input image and target image (highlighted)','FontSize',10,'FontWeight','Bold');
drawnow
% Matched filter correlator
mtchfilter=conj(fft2(TARGET));mtchfilter(1,1)=eps;
spimg=fft2(INPIMG1);
mf_corr=fftshift(real(ifft2(spimg.*mtchfilter)));
[mn StDev_mf]=std2d(mf_corr);
[X_mf,Y_mf,Mmax_mf]=locatmax(mf_corr);
SNR_mf=Mmax_mf/StDev_mf;

mask_mf=ones(SzX,SzY);
YY_mf=Y_mf-7; if YY_mf<1,YY_mf=1;end;YYY_mf=Y_mf+7;if YYY_mf>SzY, YYY_mf=SzY;end
mask_mf(X_mf-1:X_mf+1,YY_mf:YYY_mf)=zeros(3,YYY_mf-YY_mf+1);
XX_mf=X_mf-7; if XX_mf<1,XX_mf=1;end;XXX_mf=X_mf+7;if XXX_mf>SzX, XXX_mf=SzX;end
mask_mf(XX_mf:XXX_mf,Y_mf-1:Y_mf+1)=zeros(XXX_mf-XX_mf+1,3);

% Optimal adaptive  correlator
spimg2=(abs(spimg)).^2;
mask=ones(5)/25;
spimg2=conv2(spimg2,mask,'same');
opt_corr=fftshift(real(ifft2(spimg.*mtchfilter./spimg2)));
[mn StDev_oac]=std2d(opt_corr);
[X_oac,Y_oac,Mmax_oac]=locatmax(opt_corr(fix(0.1*SzX):fix(0.9*SzX),fix(0.1*SzY):fix(0.9*SzY)));
X_oac=X_oac+fix(0.1*SzX)-1;Y_oac=Y_oac+fix(0.1*SzY)-1;
SNR_oac=Mmax_oac/StDev_oac;

mask_oac=ones(SzX,SzY);
YY_oac=Y_oac-7; if YY_oac<1,YY_oac=1;end;YYY_oac=Y_oac+7;if YYY_oac>SzY, YYY_oac=SzY;end
mask_oac(X_oac-1:X_oac+1,YY_oac:YYY_oac)=zeros(3,YYY_oac-YY_oac+1);
XX_oac=X_oac-7; if XX_oac<1,XX_oac=1;end;XXX_oac=X_oac+7;if XXX_oac>SzX, XXX_oac=SzX;end
mask_oac(XX_oac:XXX_oac,Y_oac-1:Y_oac+1)=zeros(XXX_oac-XX_oac+1,3);

figure(2);
display_1([INPIMG1.*mask_mf,INPIMG1.*mask_oac]);
title('MF (left) and OAC (right)localization results','FontWeight','Bold','FontSize',10);
drawnow

figure(3);
display_1([mf_corr/Mmax_mf,opt_corr/Mmax_oac]);
title('MF (left) and OAC (right) outputs','FontWeight','Bold','FontSize',10);
drawnow

figure(4);
plot(1:SzY,opt_corr(X_oac,:)/max(opt_corr(X_oac,:)),'k-',.....
    1:SzY,mf_corr(X_mf,:)/max(mf_corr(X_mf,:)),'k-.',.....
    'LineWidth',2);
axis tight;
grid on
title(['Correlator outputs (Y-cross-sect. through position of maximum); SCR\_oac=',num2str(SNR_oac,2)],'FontWeight','Bold','FontSize',10);
xlabel('Y','FontWeight','Bold');
legend('OAC','MF')
set(gca,'FontWeight','Bold');
drawnow
%---------------------------------------------------------------------
function OUT=rad_apodmask_CRC(R);

% Central symmetric apodization mask of (2R+1)x(2R+1) pixels
% Size of the "active" area is half of the mask size
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUT=rad_apodmask(R);


X=(-R:R).^2;
X=kron(X,ones(2*R+1,1));
r=X+X';
r=1-r/max(max(r));
OUT=atan(15*(((r.*(r<0.95)+0.95*(r>=0.95)))/0.95).^20);
OUT=OUT/max(max(OUT));
%---------------------------------------------------------------------
%-----------------------------------------------------------------------------------        
 function figure_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating figure windows
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
%-------------------------------------------------------------------------------
function OUTIMG=img_ext(INPIMG,Lx,Ly);

% Image extention by mirror reflection from its borders
% by Lx,Ly pixels from the corresponding sides
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=img_ext(INPIMG,Lx,Ly);

[SzX,SzY]=size(INPIMG);

OUTIMG=[fliplr(INPIMG(:,1:Ly)),INPIMG,fliplr(INPIMG(:,SzY-Ly+1:SzY))];
OUTIMG=[flipud(OUTIMG(1:Lx,:));OUTIMG;flipud(OUTIMG(SzX-Lx+1:SzX,:))];

%-------------------------------------------------------------------------
function display_1(INPIMG)
% Displays 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display_1(INPIMG)

colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
%------------------------------------------------------------------------------
%------------------------------------------------------------------
function [mn,v]=std2d(INP);

% Standard deviation and mean of a 2-D array
% z=[mean stdeviation];
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call [mn v]=std2d(INP)

[SzX SzY]=size(INP);
mn=sum(sum(INP))/(SzX*SzY);
v=sqrt(sum(sum((INP-mn).^2))/(SzX*SzY));
%-------------------------                   ----------------

function [Xm,Ym,mx]=locatmax(INP)

% The program locates the highest maximum in a matrix INP
% Provides its value and coordinates
% OUT=[Xm Ym Maximum]
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call [Xm,Ym,mx]=locatmax(INP);

mx=max(max(INP));
[Xm,Ym]=find(INP==mx);
if size(Xm)>1,Xm=Xm(1);end
if size(Ym)>1,Ym=Ym(1);end   

%OUT=[Xm Ym mx ];
%-------------------------------------------------------------------
