function Exercises_interface;

% L. Yaroslavsky, Theoretical Foundations of Digital Imaging Using Matlab
% Interface program for exercises in Matlab
% Copyright L. Yaroslavsky, yaro@eng.tau.ac.il

close all
% figure1;
% load FrontPage;
% imshow(FrontPage,[],'Border','tight');
r=1;
while r==1;
    figure1;
    load FrontPage;
    imshow(FrontPage,[],'Border','tight');
    Ch=menu('Select a book chapter','Chapt. 3. Image digitization','Chapt. 4. Discrete signal transformations',.....
        'Chapt. 5. Digital image formation and computational imaging',......
        'Chapt. 6. Image resampling and building continuous image models',......
        'Chapt. 7. Image parameter estimation. Localization of objects in images','Chapt. 8. Image perfection');
    close all
switch Ch
    case 1,
        Ex=menu('Select exercise','Energy compaction capability of transforms','Aliasing artefacts',....
            'Ideal vs non-ideal sampling','Image quantization');
        switch Ex,
            case 1, EnergyCompact_DFT_DCT_Walsh_Haar_2D_CRC;
            case 2, fringe_aliasing_demo_CRC;
            case 3, IdealVsNonidealSampling_CRC;
            case 4, quantization_demo_CRC;
        end
    case 2,
        Ex=menu('Select exercise','The signal convolution principle','Signal even extension & convolution',......
            'Properties of DFT','DCT vs DFT domain convolution');
        switch Ex,
            case 1, convolution_demo_CRC;
            case 2, conv_evenextension_demo_CRC;
            case 3, dft_demo_CRC;
            case 4, dct_vs_dft_conv_demo_CRC;
        end
    case 3,
        Ex=menu('Select exercise','Focal plane variant and invariant hologram reconstruction',....
            'Fourier and convolution methods for Frsnel hologram reconstruction');
        switch Ex,
            case 1, FocPlaneVar_Invar_reconstr_illustr_CRC;
            case 2, Fourier_vers_conv_demo_CRC;
        end
    case 4,
         Ex=menu('Select exercise','The principle of signal sub-sampling',.....
             'Image rotation using different signal interpolation methods',......
            'Comparison of signal numerical differention methods',.....
            '"Ideal" vs "non-ideal" differention & integration methods',.....
            'Discrete direct and inverse Radon transforms through fast rotation algorithm');
        switch Ex,
            case 1, sincd_interpol_demo_CRC;
            case 2, RotateComparis_demo_CRC;
            case 3, differentiator_comparison_CRC;
            case 4, differentiat_integrat_error_CRC;
            case 5, radon_invradon_demo_CRC;
        end
    case 5,
        Ex=menu('Select exercise','Localization of a target on empty background','Localization errors',......
            '"Matched filter" correlator vs SCR-optimal correlator','Local vs globas SCR-optimal correlators');
        switch Ex,
            case 1, localization_demo_CRC;
            case 2, loclzerr_CRC;
            case 3, corr_comparison_CRC;
            case 4, Lcoptcorr_CRC;
        end
    case 6,
        Ex=menu('Select exercise','Filtering periodical interferences',.....
             'Filtering "banding" noise',......
            '"Ideal" and Empirical Wiener filtering for image de-noising and de-blurring',.....
            'Local adaptive filtering for image de-nosing',.....
            'Filtering impulse interferences',......
            'Standardization of image histograms',....
            'Demonstration of pixel neighborhoods',....
            'Image enhancement demo',...
            'Empirical evaluation of noise level in images');
        switch Ex,
            case 1, demoire1_CRC;
            case 2, filtering_stripes_CRC;
            case 3, WienerFilter_CRC;
            case 4, demo_lcdct2_CRC;
            case 5, impulse_noise_filtering_demo_CRC;
            case 6, Histo_standardization_CRC;
            case 7, Neighborhoods_CRC;
            case 8, enhancement_demo_CRC;
            case 9, NoiseVar_CRC.m;
        end
        
end
% figure1;
% imshow(FrontPage,[],'Border','tight');
r=menu('Another exercise?','Yes','No');
end
close all
%------------------------------------------------------------
function figure1;
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call fig_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
% close all;
%    Nvert=1;Nhor=2;
   H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
%    figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
figure('Position',[30+H_Sz VerSz-90-H_Sz H_Sz H_Sz]);colormap(gray(256))


%-----------------------------------------------